// Generated by CoffeeScript 1.9.0
'use strict';
var Callinfo, Producer, debug, exec, fs, isWatching, logger, watcher, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

_ = require("lodash");

fs = require('fs');

exec = require("child_process").exec;

Producer = require('class_node_producer');

logger = require("omg-logger");

isWatching = false;

watcher = false;

debug = require("debug")("omg-callinfo");

Callinfo = (function(_super) {
  __extends(Callinfo, _super);

  function Callinfo() {
    this.subscribe = __bind(this.subscribe, this);
    Callinfo.__super__.constructor.call(this, "callinfo", 15 * 1000);
    this.start = (function(_this) {
      return function() {
        var onSomethingChanged, watchDir;
        debug("starting");
        _this.debug = debug;
        watchDir = "/tmp/";

        /*
        checks if changed file was BChannelState, then runs getChannelLogs.lua and sends result through zmq to prod manager
         */
        onSomethingChanged = function(event, filename) {
          if (filename.lastIndexOf("BChannelState", 0) === 0 || filename.lastIndexOf("isdn-call-", 0) === 0) {
            return exec("./getChannelLogs.lua", {
              cwd: __dirname + "/lua/"
            }, function(error, stdout, stderr) {
              var returnObject;
              if (error) {
                logger.error(error);
              }
              if (stderr) {
                logger.warn(stderr);
              }
              debug("sending callinfo changes because " + filename + " changed");
              returnObject = {};
              stdout = JSON.parse(stdout);
              _.each(stdout, function(call) {
                return returnObject[call.name] = call;
              });
              return _this.sendData(returnObject);
            });
          }
        };

        /*! */
        watcher = fs.watch(watchDir, _.throttle(onSomethingChanged, 3000));
        return onSomethingChanged(null, "BChannelState");
      };
    })(this);
    this.stop = function() {
      watcher.close();
      return isWatching = false;
    };
  }

  Callinfo.prototype.subscribe = function() {
    if (!isWatching) {
      isWatching = true;
      this.start();
    }
    return Callinfo.__super__.subscribe.apply(this, arguments);
  };

  return Callinfo;

})(Producer);

module.exports = new Callinfo();
