// Generated by CoffeeScript 1.9.0

/*
* omg-configurator
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
'use strict';
var Configurator, Producer, convertFile, convertedConfigPath, debug, exec, fs, getConfigFileEncoding, originalConfigPath, sh,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

fs = require('fs');

exec = require("child_process").exec;

sh = require("shelljs");

debug = require("debug")("omg-configurator");

Producer = require("class_node_producer");

originalConfigPath = "/data/config.lua";

convertedConfigPath = "/data/config.utf.lua";

getConfigFileEncoding = function(cb) {
  return exec("file " + originalConfigPath, function(error, stdout, stderr) {
    stdout = stdout.toString();
    stdout = stdout.replace(/\/data\/config\.lua\:|text|\ |\n/g, "");
    debug(stdout);
    return cb(stdout);
  });
};

convertFile = function(needsConversion, cb) {
  if (!needsConversion) {
    sh.cp("-f", originalConfigPath, convertedConfigPath);
    cb();
    return;
  }
  return exec("iconv -f ISO_8859-1 -t UTF-8 " + originalConfigPath + " -o " + convertedConfigPath, function(error, stdout, stderr) {
    debug("converted config.lua: " + stdout);
    return cb();
  });
};

Configurator = (function(_super) {
  __extends(Configurator, _super);

  function Configurator() {
    var extracted_struct_DChannel;
    Configurator.__super__.constructor.call(this, "configurator");
    extracted_struct_DChannel = function(data) {
      return data.config.struct_Box.struct_DChannel;
    };
    this.get = (function(_this) {
      return function(filename, callback) {
        return getConfigFileEncoding(function(encoding) {
          var needsConversion;
          if (encoding === "ISO-8859") {
            needsConversion = true;
            debug("Encoding of config.lua is " + encoding + ". Needs conversion");
          }
          return convertFile(needsConversion, function() {
            var filepath, preCallback, readTimeout, success, timeoutSeconds;
            switch (filename) {
              case "config.lua":
                filepath = "" + convertedConfigPath;
                break;
              case "config.lua struct_DChannel":
                filepath = "" + convertedConfigPath;
                preCallback = extracted_struct_DChannel;
                break;
              case "config.test":
                filepath = "/data/config.test";
                break;
              default:
                callback("I don't know that config file!");
                return;
            }
            success = false;
            exec(__dirname + "/lua/readConfig.lua '" + filepath + "'", function(error, stdout, stderr) {
              if (error) {
                console.log(error);
              }
              if (stderr) {
                console.log(stderr);
              }
              stdout = JSON.parse(stdout);
              if (preCallback) {
                stdout = preCallback(stdout);
              }
              if (stdout) {
                debug("omg-configurator.js sending data: " + stdout);
                _this.replyData(stdout, callback);
              } else {
                _this.replyData("", callback);
              }
              return success = true;
            });
            timeoutSeconds = 10;
            readTimeout = function() {
              if (success) {
                return;
              }
              callback("Read of " + filename + " timed out after " + timeoutSeconds + " seconds");
              return _this.replyData("Error");
            };
            return setTimeout(readTimeout, timeoutSeconds * 1000);
          });
        });
      };
    })(this);
  }

  return Configurator;

})(Producer);

module.exports = new Configurator();
