// Generated by CoffeeScript 1.9.0

/*
* omg-memoryusage
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
'use strict';
var Memoryusage, Producer, debug, os,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

os = require("os");

debug = require("debug")("omg-memoryusage");

Producer = require("class_node_producer");

Memoryusage = (function(_super) {
  var isRunning;

  __extends(Memoryusage, _super);

  isRunning = false;

  function Memoryusage() {
    this.subscribe = __bind(this.subscribe, this);
    var getNewData, run;
    Memoryusage.__super__.constructor.call(this, "memoryusage", 10 * 1000);
    getNewData = false;
    run = (function(_this) {
      return function() {
        var memory;
        memory = {
          total: (os.totalmem() / 1048576).toFixed(0),
          free: (os.freemem() / 1048576).toFixed(0)
        };
        debug("sending memory usage. Free: " + memory.free);
        return _this.sendData(memory);
      };
    })(this);
    run();
    this.start = (function(_this) {
      return function() {
        _this.debug("starting");
        run();
        if (getNewData) {
          clearInterval(getNewData);
        }
        return getNewData = setInterval(run, 10 * 1000);
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        if (getNewData) {
          clearInterval(getNewData);
        }
        return isRunning = false;
      };
    })(this);
  }

  Memoryusage.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return Memoryusage.__super__.subscribe.apply(this, arguments);
  };

  return Memoryusage;

})(Producer);

module.exports = new Memoryusage();
