// Generated by CoffeeScript 1.9.0

/*
* omg-messagingservers
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
'use strict';
var MessagingServers, Producer, async, config2object, debug, exec, fs, isCurrentJCFile, isJCFile, ko, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

_ = require("lodash");

fs = require('fs');

exec = require("child_process").exec;

ko = require("knockout");

debug = require("debug")("omg-messagingservers");

async = require('async');

Producer = require("class_node_producer");

config2object = function(string) {
  var asArray, oneServer, toBeObject;
  string = string.replace(/\n/g, "");
  asArray = string.split(" --");
  asArray = asArray.slice(1);
  asArray = (function() {
    var _i, _len, _results;
    _results = [];
    for (_i = 0, _len = asArray.length; _i < _len; _i++) {
      toBeObject = asArray[_i];
      _results.push(toBeObject.split("="));
    }
    return _results;
  })();
  return oneServer = _.object(asArray);
};

isJCFile = function(filename) {
  return filename.lastIndexOf("JC-", 0) === 0;
};

isCurrentJCFile = function(filename) {
  return filename.lastIndexOf("JC-", 0) === 0 && filename.lastIndexOf("JC-D", 0) !== 0;
};

MessagingServers = (function(_super) {
  var isRunning, watchDir, watcher;

  __extends(MessagingServers, _super);

  isRunning = false;

  watcher = false;

  watchDir = "/tmp/";

  function MessagingServers() {
    this.subscribe = __bind(this.subscribe, this);
    var addMessagingServer, allMessagingServers, filesChanged, run, sendNewData, throttledRunAfterFileChange;
    MessagingServers.__super__.constructor.call(this, "messagingservers", 10 * 1000);
    allMessagingServers = {};
    filesChanged = ko.observable().extend({
      notify: "always"
    });
    sendNewData = (function(_this) {
      return function() {
        debug("sending data " + (JSON.stringify(allMessagingServers)));
        allMessagingServers = _.sortBy(allMessagingServers, "ilid_index");
        _this.sendData(allMessagingServers, true);
        return _this.sendData(allMessagingServers);
      };
    })(this);
    addMessagingServer = function(filename, asyncCallback) {
      var filenameIndex;
      filenameIndex = filename;
      return fs.readFile("" + watchDir + filename, function(err, data) {
        if (data) {
          data = data.toString();
          data = config2object(data);
          if (data.partner) {
            data.partner = data.partner.split("|")[1];
          }
          if (data.ilid_index) {
            data.ilid_index = JSON.parse(data.ilid_index);
          }
          if (data.date) {
            data.date = JSON.parse(data.date);
          }
          if (data.partner && data.partner !== ("127.0.0.1" || "none")) {
            allMessagingServers[filenameIndex] = data;
          }
        }
        return asyncCallback();
      });
    };
    run = (function(_this) {
      return function() {
        allMessagingServers = {};
        return fs.readdir(watchDir, function(err, files) {
          var currentJCFiles, filename, jcFiles;
          jcFiles = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = files.length; _i < _len; _i++) {
              filename = files[_i];
              if (isJCFile(filename)) {
                _results.push(filename);
              }
            }
            return _results;
          })();
          currentJCFiles = _.filter(jcFiles, isCurrentJCFile);
          return async.map(currentJCFiles, addMessagingServer, sendNewData);
        });
      };
    })(this);
    run();
    throttledRunAfterFileChange = ko.computed(function() {
      if (filesChanged() === true) {
        return run();
      }
    }).extend({
      throttle: 1000
    });
    this.start = (function(_this) {
      return function() {
        _this.debug("starting");
        run();
        if (watcher) {
          watcher.close();
        }
        watcher = false;
        return watcher = fs.watch(watchDir, function(event, filename) {
          if (isJCFile(filename)) {
            debug(filename + " changed");
            return filesChanged(true);
          }
        });
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        isRunning = false;
        watcher.close();
        watcher = false;
        _this.sendStatus("stopped");
        return isRunning = false;
      };
    })(this);
  }

  MessagingServers.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return MessagingServers.__super__.subscribe.apply(this, arguments);
  };

  return MessagingServers;

})(Producer);

module.exports = new MessagingServers();
