// Generated by CoffeeScript 1.9.0
var Numberlist, Producer, async, child_process, debug, fs, validateFilename,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

fs = require('fs');

Producer = require("class_node_producer");

child_process = require('child_process');

debug = require("debug")("omg-numberlist");

async = require('async');

if (!fs.existsSync("/data/numberlists/")) {
  fs.mkdirSync("/data/numberlists/");
}

validateFilename = function(filename) {
  filename = filename.replace(/\/|\"|\\|/ | /./g, "");
  return filename = filename + ".lst";
};

Numberlist = (function(_super) {
  var isRunning;

  __extends(Numberlist, _super);

  isRunning = false;

  function Numberlist() {
    this.check = __bind(this.check, this);
    var readNumberList;
    Numberlist.__super__.constructor.call(this, "numberlist");
    readNumberList = function(filename, cb) {
      return child_process.exec("blwl t /data/" + filename, function(error, stdout, stderr) {
        if (stdout) {
          stdout = stdout.toString();
          debug("read " + filename + ": " + stdout);
          return cb(null, {
            name: filename.replace(".lst", ""),
            numbers: stdout
          });
        } else {
          debug("list " + filename + " could not be read");
          return cb(error || stderr || "error");
        }
      });
    };
    this.getListNames = (function(_this) {
      return function(callback) {
        return fs.readdir("/data/numberlists", function(err, res) {
          if (res && res.length) {
            debug("found numberlists: " + res);
            return async.map(res, readNumberList, function(err, lists) {
              debug("lists with numbers: " + (JSON.stringify(lists)));
              return _this.replyData({
                lists: lists
              }, callback);
            });
          } else {
            debug("no numberlists present");
            return _this.replyData("empty", callback);
          }
        });
      };
    })(this);
    this["delete"] = (function(_this) {
      return function(filename, callback) {
        filename = validateFilename(filename);
        debug("deleting " + filename);
        return fs.unlink("/data/" + filename, function(err) {
          var err1;
          if (err) {
            err1 = err;
          }
          return fs.unlink("/data/numberlists/" + filename, function(err) {
            if (!(err || err1)) {
              _this.replyData(filename + " deleted", callback);
            }
            if (err || err1) {
              return _this.replyError(err || err1, callback);
            }
          });
        });
      };
    })(this);
    this.set = (function(_this) {
      return function(numbersObject, callback) {
        var filename, num, nums;
        debug("received request to store " + numbersObject);
        try {
          numbersObject = JSON.parse(numbersObject);
        } catch (_error) {}
        if (numbersObject) {
          debug("storing " + numbersObject.filename);
          debug("storing " + numbersObject.numbers);
          if (numbersObject.filename) {
            filename = validateFilename(numbersObject.filename);
          }
          numbersObject.numbers = (function() {
            var _i, _len, _ref, _results;
            _ref = numbersObject.numbers;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              num = _ref[_i];
              if (num) {
                _results.push(num);
              }
            }
            return _results;
          })();
          if (numbersObject.numbers && numbersObject.numbers[0]) {
            nums = numbersObject.numbers.join("\n");
            debug("numbers to be stored in " + filename + ": " + nums);
          }
          if (nums && filename) {
            return fs.writeFile("/data/numberlists/" + filename, nums, function(err, res) {
              if (err) {
                _this.replyError("could not write file 1", callback);
                return;
              }
              return child_process.exec("blwl c /data/numberlists/" + filename + " /data/" + filename, function(error, stdout, stderr) {
                if (error) {
                  console.log(error);
                }
                if (stderr) {
                  console.log(stderr);
                }
                if (stdout) {
                  console.log(stdout);
                }
                if (error || stderr) {
                  return _this.replyError(error || stderr, callback);
                } else {
                  readNumberList(filename, function(err, list) {
                    return _this.replyData(list || "error", callback);
                  });
                  return;
                  return child_process.exec("blwl t /data/" + filename, function(error, stdout, stderr) {
                    if (stdout) {
                      stdout = stdout.toString();
                    }
                    return _this.replyData(stdout || "error", callback);
                  });
                }
              });
            });
          } else {
            return _this.replyError("could not write file. Numbers or file name invalid", callback);
          }
        } else {
          return _this.replyError("No numbers or no file name specified", callback);
        }
      };
    })(this);
  }

  Numberlist.prototype.check = function(numbersObject, callback) {
    var command, filename;
    filename = validateFilename(numbersObject.filename);
    command = "blwl f /data/" + filename + " " + numbersObject.numberToCheck;
    debug(command);
    return child_process.exec(command, (function(_this) {
      return function(error, stdout, stderr) {
        if (error) {
          console.log(error);
        }
        if (stderr) {
          console.log(stderr);
        }
        if (stdout) {
          console.log(stdout);
        }
        if (stdout) {
          stdout = stdout.toString();
          stdout = stdout.replace(/\n|[a-z]|\=/g, "");
          return _this.replyData(stdout, callback);
        } else {
          return _this.replyError("err", callback);
        }
      };
    })(this));
  };

  return Numberlist;

})(Producer);

module.exports = new Numberlist();
