// Generated by CoffeeScript 1.9.0
"use strict";
var Producer, Tcpdump, async, debug, getmac, logger, path, spawn, _,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

_ = require("lodash");

path = require("path");

spawn = require("child_process").spawn;

async = require('async');

getmac = require('getmac');

logger = require("omg-logger");

debug = require("debug")("omg-tcpdump");

Producer = require("class_node_producer");

Tcpdump = (function(_super) {
  var isRunning, tcpProcess, tcpTimer;

  __extends(Tcpdump, _super);

  isRunning = false;

  tcpProcess = void 0;

  tcpTimer = void 0;

  function Tcpdump() {
    Tcpdump.__super__.constructor.call(this, "tcpdump");
    this.start = (function(_this) {
      return function(device, duration) {
        var args, command, e, filter;
        _this.debug("starting");
        if (!duration) {
          logger.warn("You must specify a duration");
          _this.sendError("You must specify a duration");
          return;
        }
        logger.debug("setting tcpdump timeout to " + duration + " minutes");
        if (tcpTimer) {
          logger.debug("clearing tcpdump timeout");
          clearTimeout(tcpTimer);
        }
        tcpTimer = setTimeout(_this.stop, duration * 1000 * 60);
        command = void 0;
        filter = void 0;
        args = void 0;
        if (tcpProcess && !tcpProcess.killed) {
          _this.sendError("tcpdump already running");
          return;
        }
        _this.sendStatus("started");
        filter = " not port 514 and not port 22";
        command = "tcpdump";
        try {
          fs.unlinkSync("/tmp/logs/capture.cap");
        } catch (_error) {
          e = _error;
        }
        args = ["-a", "-U", "-i", "any", "-w", "/tmp/logs/capture.cap", "-p", "-n", "-s", "0", filter];
        logger.debug("running " + command + " " + args.join(" "));
        tcpProcess = spawn(command, args);
        _this.sendStatus("running");
        tcpProcess.stdout.on("data", function(data) {
          return logger.debug("tcpdump stdout: " + data);
        });
        tcpProcess.stderr.on("data", function(data) {
          logger.debug("tcpdump stderr: " + data);
          return _this.sendData(data.toString());
        });
        return tcpProcess.on("exit", function(err, code) {
          if (code) {
            _this.sendData(code);
          }
          if (err) {
            _this.sendError(err);
          }
          return _this.sendStatus("stopped");
        });
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        isRunning = false;
        if (tcpProcess && !tcpProcess.killed) {
          tcpProcess.on("error", function(err) {
            this.sendError("tcpdump error: " + err.message);
          });
          tcpProcess.kill();
        } else {
          logger.error("tcpProcess is not defined, or already killed");
          _this.sendStatus("stopped");
        }
        if (tcpTimer) {
          logger.debug("clearing tcpdump timeout");
          return clearTimeout(tcpTimer);
        }
      };
    })(this);
  }

  return Tcpdump;

})(Producer);

module.exports = new Tcpdump();
