// Generated by CoffeeScript 1.9.0
"use strict";
var AggConnection, EventEmitter, Producer, Testcall, appConfig, async, callProcess, callTries, checkFreePort, debug, emitter, exec, freeport, gatelogs, l2xConverter, logger, loglines, removeOldLogFiles, runAsRoot, shell, spawn, startGateLogs, testcallFolder, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

exec = require("child_process").exec;

spawn = require("child_process").spawn;

_ = require("lodash");

freeport = require("freeport");

shell = require("shelljs");

logger = require("omg-logger");

async = require('async');

debug = require("debug")("omg-testcall");

EventEmitter = require('events').EventEmitter;

emitter = new EventEmitter();

Producer = require("class_node_producer");

appConfig = global.appConfig;

if (appConfig) {
  runAsRoot = appConfig.sudo || false;
}

AggConnection = require('./aggConnection.js');

gatelogs = new AggConnection("gatelogs");

l2xConverter = require('./l2xconverter.js');

testcallFolder = "/tmp/testcall";

if (!shell.test("-e", testcallFolder)) {
  shell.mkdir(testcallFolder);
}

shell.cp("-f", __dirname + "/files/*", testcallFolder + "/");

callProcess = void 0;

callTries = 0;

loglines = [];

startGateLogs = function(asyncCallback) {
  var onMessage;
  onMessage = function(producer, message) {
    var e;
    try {
      message = JSON.parse(message);
    } catch (_error) {
      e = _error;
      logger.error(e);
    }
    if (message.status === "running") {
      gatelogs.subSocket.removeListener("message", onMessage);
      return asyncCallback(null, "running");
    }
  };
  gatelogs.subSocket.on("message", onMessage);
  return gatelogs.start([2]);
};

removeOldLogFiles = function(asyncCallback) {
  return exec("rm -f " + testcallFolder + "/*.log", function(e, out) {
    return asyncCallback(e, out);
  });
};

checkFreePort = function(asyncCallback) {
  return freeport((function(_this) {
    return function(error, res) {
      return asyncCallback(error, res);
    };
  })(this));
};

Testcall = (function(_super) {
  __extends(Testcall, _super);

  function Testcall() {
    this.stop = __bind(this.stop, this);
    this.start = __bind(this.start, this);
    Testcall.__super__.constructor.call(this, "testcall");
    this.running = false;
  }

  Testcall.prototype.start = function(callObject) {
    var logsDuringCall, startCall, that;
    async.parallel({
      gatelogsRunning: startGateLogs,
      removeOldLogFiles: removeOldLogFiles,
      freePort: checkFreePort
    }, (function(_this) {
      return function(err, results) {
        if (err) {
          _this.sendError(err);
          return;
        }
        debug(results);
        if (!err) {
          return startCall();
        }
      };
    })(this));
    that = this;
    logsDuringCall = [];
    return startCall = (function(_this) {
      return function() {
        var callingPartyName, optionsPath, redirectedNumber, sippOptions;
        redirectedNumber = callObject.redirectedNumber;
        callingPartyName = callObject.callerName;
        optionsPath = testcallFolder + "/options.xml";
        if (redirectedNumber && !callingPartyName) {
          optionsPath = testcallFolder + "/options_redirected.xml";
        }
        if (!redirectedNumber && callingPartyName) {
          optionsPath = testcallFolder + "/options_callername.xml";
        }
        if (redirectedNumber && callingPartyName) {
          optionsPath = testcallFolder + "/options_callername_redirected.xml";
        }
        sippOptions = ["-skip_rlimit -silent -max_socket 50000 -sf " + optionsPath + " -mp 6000 -trace_msg -trace_shortmsg -trace_logs -trace_err -m 1 -users 1 -pause_msg_ign"];
        return exec(__dirname + "/bash/primaryAddress.sh", function(error, stdout) {
          var argCmd, args, command, localAddress, msg, onGatelogsMessage;
          localAddress = void 0;
          msg = void 0;
          if (error) {
            msg = "Could not dertermine localAddress! (" + __dirname + "/bash/primaryAddress.sh failed!)";
            logger.error(msg);
            throw new Error(msg);
          }
          localAddress = stdout.replace(/\n/g, "");
          if (runAsRoot) {
            command = "sudo";
            args = ["sipp"];
          } else {
            command = "sipp";
            args = [];
          }
          args.push(callObject.host + ":" + callObject.port);
          switch (callObject.proto.toUpperCase()) {
            case "TCP":
              args.push("-t t1");
              break;
            case "TLS":
              args.push("-t l1");
              break;
            case "UDP":
              args.push("-t u1");
          }
          args.push("-i " + localAddress);
          args.push("-mi " + localAddress);
          args.push("-s " + callObject.calledPartyNumber);
          args.push("-set callingPartyNumber " + callObject.callingPartyNumber);
          if (redirectedNumber) {
            args.push("-set redirectedNumber " + redirectedNumber);
          }
          if (callingPartyName) {
            args.push("-set callingPartyName " + callingPartyName);
          }
          argCmd = args.concat(sippOptions);
          argCmd = argCmd.join(" ").split(new RegExp(" "));
          logger.info("running testcall:\n " + command + " " + (argCmd.join(' ')));
          _this.sendStatus("started");
          callProcess = spawn(command, argCmd, {
            cwd: "/tmp/"
          });
          _this.sendStatus("running");
          callProcess.on("error", function(err) {
            logger.error("testcall spawn error on: " + argCmd);
            _this.sendError(err);
          });
          callProcess.stderr.on("data", function(data) {
            var match;
            data = data.toString("utf-8");
            match = data.match("Address already in use");
            if (match) {
              if (callTries < 1) {
                callTries++;
                that.stop((function(_this) {
                  return function() {
                    logger.warn("Killing running testcall and trying again.");
                    _this.sendData("Killing running testcall and trying again.");
                    return setTimeout(that.start(callObject), 2000);
                  };
                })(this));
              } else {
                that.stop((function(_this) {
                  return function() {
                    callTries = 0;
                    logger.warn("Too many retries, canceling!");
                    _this.sendData("Too many retries, canceling!");
                  };
                })(this));
              }
            }
          });
          callProcess.on("exit", function() {
            _this.sendStatus("stopped");
            return emitter.emit("shutItAllDown");
          });
          callProcess.stdout.on("data", function(data) {});
          callProcess.on("close", function(code) {
            logger.info("closing " + code);
            emitter.emit("shutItAllDown", code);
            _this.sendStatus("stopped");
          });
          onGatelogsMessage = function(message) {
            var outArray;
            outArray = [];
            _.each(message.outputMessage, function(line, index) {
              var hexString, l3Line, l3dLines, newLine, splitLine, splitNewLine, time;
              if (line.match(/L2X/i)) {
                splitLine = line.split(":");
                hexString = splitLine.pop();
                line = splitLine.join(":");
                l3dLines = l2xConverter(hexString);
                if (l3dLines && l3dLines.length) {
                  l3Line = l3dLines[0];
                  newLine = line + ": " + l3Line;
                  newLine = newLine.split("L2X : ")[1];
                  splitNewLine = newLine.split(" ");
                  time = splitNewLine[1];
                  time = time.replace(/\.|\,/g, ":");
                  splitNewLine[1] = time + " ";
                  newLine = splitNewLine.join(" ");
                  outArray.push(newLine);
                  l3dLines.shift();
                  return _.each(l3dLines, function(l3Line, index) {
                    return outArray.push("                            " + l3Line);
                  });
                }
              }
            });
            if (outArray.length) {
              _this.sendData(outArray);
            }
            if (message.status && message.status === "stopped") {
              return _this.sendStatus("stopped");
            }
          };
          gatelogs.onSub(onGatelogsMessage);
          return emitter.once("shutItAllDown", function(code) {
            var stopGatelogs;
            if (callProcess !== undefined && callProcess.killed !== true) {
              callProcess.kill();
            }
            stopGatelogs = function() {
              return gatelogs.stop();
            };
            return setTimeout(stopGatelogs, 100);
          });
        });
      };
    })(this);
  };

  Testcall.prototype.stop = function(callback) {
    emitter("shutItAllDown", "manual stop");
    return exec("/usr/bin/killall -s 9 sipp >/dev/null 2>&1; echo -n $?", function(err) {
      if (!err) {

      } else {
        return logger.error(err);
      }
    });
  };

  return Testcall;

})(Producer);

module.exports = new Testcall();
