// Generated by CoffeeScript 1.9.0

/*
* omg-uptime
*
* Copyright (c) 2014 Johannes Noe
* Licensed under the MIT license.
 */
'use strict';
var Producer, Uptime, async, debug, exec, os, returnObject,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

os = require("os");

exec = require("child_process").exec;

async = require("async");

debug = require("debug")("omg-uptime");

Producer = require("class_node_producer");

Uptime = (function(_super) {
  var isRunning;

  __extends(Uptime, _super);

  isRunning = false;

  function Uptime() {
    this.subscribe = __bind(this.subscribe, this);
    var getNewData, getUptime, getcpus, getloadavg, gettime, getusers, run;
    Uptime.__super__.constructor.call(this, "uptime", 10 * 1000);
    getcpus = function(asyncCallback) {
      var cpus;
      cpus = os.cpus().length;
      return asyncCallback(null, cpus);
    };
    getUptime = function(asyncCallback) {
      var hours, minutes, result, seconds, totalSec;
      totalSec = os.uptime();
      hours = parseInt(totalSec / 3600, 10) % 24;
      minutes = parseInt(totalSec / 60, 10) % 60;
      seconds = parseInt(totalSec % 60, 10);
      result = hours < 10 ? "0" + hours : hours;
      result = result + ":";
      result = result + (minutes < 10 ? "0" + minutes : minutes);
      result = result + ":";
      result = result + (seconds < 10 ? "0" + seconds : seconds);
      return asyncCallback(null, result);
    };
    gettime = function(asyncCallback) {
      var time;
      time = ((new Date()).toTimeString()).substring(0, 8);
      return asyncCallback(null, time);
    };
    getloadavg = function(asyncCallback) {
      var load;
      load = (function() {
        var _i, _len, _ref, _results;
        _ref = os.loadavg();
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          load = _ref[_i];
          _results.push(load.toFixed(2));
        }
        return _results;
      })();
      return asyncCallback(null, load);
    };
    getusers = function(asyncCallback) {
      return exec("users", function(err, stdout) {
        var users;
        users = stdout.split(" ").length;
        return asyncCallback(null, users);
      });
    };
    getNewData = false;
    run = (function(_this) {
      return function() {
        var returnObject, toRunInParallel;
        returnObject = {};
        toRunInParallel = {
          cpus: getcpus,
          uptime: getUptime,
          time: gettime,
          loadavg: getloadavg,
          users: getusers
        };
        return async.parallel(toRunInParallel, function(err, results) {
          return _this.sendData(results);
        });
      };
    })(this);
    run();
    this.start = (function(_this) {
      return function() {
        _this.debug("starting");
        run();
        if (getNewData) {
          clearInterval(getNewData);
        }
        return getNewData = setInterval(run, 2 * 1000);
      };
    })(this);
    this.stop = (function(_this) {
      return function() {
        if (getNewData) {
          clearInterval(getNewData);
        }
        return isRunning = false;
      };
    })(this);
  }

  Uptime.prototype.subscribe = function() {
    if (!isRunning) {
      isRunning = true;
      this.start();
    }
    return Uptime.__super__.subscribe.apply(this, arguments);
  };

  return Uptime;

})(Producer);

module.exports = new Uptime();

return;

returnObject = {};

returnObject.cpus = os.cpus().length;

exports.start = function(callback) {
  var hours, load, minutes, result, seconds, totalSec;
  totalSec = os.uptime();
  hours = parseInt(totalSec / 3600, 10) % 24;
  minutes = parseInt(totalSec / 60, 10) % 60;
  seconds = parseInt(totalSec % 60, 10);
  result = hours < 10 ? "0" + hours : hours;
  result = result + ":";
  result = result + (minutes < 10 ? "0" + minutes : minutes);
  result = result + ":";
  result = result + (seconds < 10 ? "0" + seconds : seconds);
  returnObject.uptime = result;
  returnObject.time = ((new Date()).toTimeString()).substring(0, 8);
  returnObject.loadavg = (function() {
    var _i, _len, _ref, _results;
    _ref = os.loadavg();
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      load = _ref[_i];
      _results.push(load.toFixed(2));
    }
    return _results;
  })();
  return exec("users", function(err, stdout) {
    returnObject.users = stdout.split(" ").length;
    return callback(null, returnObject);
  });
};
